Support pkg-config for SSL libraries.
[exim.git] / src / scripts / Configure-Makefile
CommitLineData
61ec970d 1#! /bin/sh
61ec970d
PH
2
3# Shell script to build Makefile in a build directory. It must be called
4# from inside the directory. It does its own checking of when to rebuild; it
5# just got too horrendous to get it right in "make", because of the optionally
6# existing configuration files.
7
8
9# First off, get the OS type, and check that there is a make file for it.
10
11ostype=`../scripts/os-type -generic` || exit 1
12
13if [ ! -r ../OS/Makefile-$ostype ] ; then
14 echo ""
15 echo "*** Sorry - operating system $ostype is not supported"
16 echo "*** See OS/Makefile-* for supported systems" 1>&2
17 echo ""
18 exit 1
19fi
20
21# We also need the architecture type, in order to test for any architecture-
22# specific configuration files.
23
24archtype=`../scripts/arch-type` || exit 1
25
26# Now test for either the non-existence of Makefile, or for any of its
27# components being newer. Note that the "newer" script gives the right
28# answer (for our purposes) when the first file is non-existent.
29
30editme=../Local/Makefile
31rebuild=yes
32
33if [ -f Makefile ] ; then
34 rebuild=no
35 if ../scripts/newer $editme Makefile || \
36 ../scripts/newer $editme-$ostype Makefile || \
37 ../scripts/newer $editme-$archtype Makefile || \
38 ../scripts/newer $editme-$ostype-$archtype Makefile || \
39 ../scripts/newer ../scripts/Configure-Makefile Makefile || \
40 ../scripts/newer ../OS/Makefile-Base Makefile || \
41 ../scripts/newer ../OS/Makefile-Default Makefile
42 then
43 rebuild=yes
44 fi
45fi
46
47# If the "build" variable is set it means that a build name was explicitly
48# given. Arrange to pick up a build-specific configuration file.
49
50if [ "X$build" != "X" ] ; then
51 mfb=Local/Makefile-$build
52 if ../scripts/newer $editme-$build Makefile ; then
53 rebuild=yes
54 fi
55else
56 mfb=
57fi
58
59
60# If Makefile is up-to-date, no need to rebuild it.
61
62if [ $rebuild = no ] ; then
63 echo "\`Makefile' is up to date."
64 echo " "
65 exit
66fi
67
68# Makefile needs to be rebuilt in the current directory by joining
69# the generic default makefile, the OS base makefile, and then local
70# generic, OS-specific, architecture-specific, and OS+architecture-specific
71# makefiles, if they exist. These files all contain macro definitions, with
72# later definitions overriding earlier ones. Make a temporary file first, in
73# case things go wrong. A second temporary is needed for sorting out the
74# default Perl stuff. Use short macro names to save typing.
75
76mf=Makefile
77mft=$mf-t
78mftt=$mf-tt
79
0a349494
PP
80look_mf=lookups/Makefile.predynamic
81look_mft=${look_mf}-t
82
61ec970d
PH
83# Ensure the temporary does not exist and start the new one by setting
84# the OSTYPE and ARCHTYPE variables.
85
0a349494 86rm -f $mft $mftt $look_mf-t
61ec970d
PH
87(echo "OSTYPE=$ostype"; echo "ARCHTYPE=$archtype"; echo "") > $mft || exit 1
88
89# Now concatenate the files to the temporary file. Copy the files using sed to
90# remove comments, blank lines, and trailing white space.
91
92# BEWARE: a tab character is needed in the sed command below. It has had
93# a nasty tendency to get lost in the past, causing a problem if a tab has
94# actually been present in one of the files. Use a variable to hold a space
95# and a tab to keep the tab in one place.
96
97st=' '
98
99for f in OS/Makefile-Default \
100 OS/Makefile-$ostype \
101 Local/Makefile \
102 Local/Makefile-$ostype \
103 Local/Makefile-$archtype \
104 Local/Makefile-$ostype-$archtype \
105 $mfb
106do if test -r ../$f
107 then echo "# From $f"
108 sed "/^#/d;/^[$st]*\$/d;s/[$st]*\$//" ../$f || exit 1
109 echo "# End of $f"
110 echo ""
111 fi
0a349494
PP
112done >> $mft || exit 1
113
dde3daac
PP
114# handle pkg-config
115# beware portability of extended regexps with sed.
116
117egrep "^[$st]*(AUTH|LOOKUP)_[A-Z0-9_]*[$st]*=[$st]*" $mft | \
118 sed "s/[$st]*=/='/" | \
119 sed "s/\$/'/" > $mftt
f4b00a2d
PP
120egrep "^[$st]*((USE_(OPENSSL|GNUTLS)_PC)|SUPPORT_TLS|USE_GNUTLS)[$st]*=[$st]*" $mft | \
121 sed "s/[$st]*=/='/" | \
122 sed "s/\$/'/" >> $mftt
dde3daac
PP
123if test -s $mftt
124then
125 (
126 echo "# pkg-config fixups"
127 . ./$mftt
128 for var in `cut -d = -f 1 < $mftt`; do
129 case $var in
f4b00a2d
PP
130
131 USE_*_PC)
132 eval "pc_value=\"\$$var\""
133 need_this=''
134 if [ ".$SUPPORT_TLS" = "." ]; then
135 # no TLS, not referencing
136 true
137 elif [ ".$var" = ".USE_GNUTLS_PC" ] && [ ".$USE_GNUTLS" != "." ]; then
138 need_this=t
139 elif [ ".$var" = ".USE_OPENSSL_PC" ] && [ ".$USE_GNUTLS" = "." ]; then
140 need_this=t
141 fi
142 if [ ".$need_this" != "." ]; then
143 tls_include=`pkg-config --cflags $pc_value`
144 tls_libs=`pkg-config --libs $pc_value`
145 echo "TLS_INCLUDE=$tls_include"
146 echo "TLS_LIBS=$tls_libs"
147 fi
148 ;;
149
dde3daac
PP
150 *_PC)
151 eval "pc_value=\"\$$var\""
152 base=`echo $var | sed 's/_PC$//'`
153 eval "basevalue=\"\$$base\""
154 if [ ".$basevalue" = "." ]; then
155 # not pulling in this module, _PC defined as default? Ignore
156 true
157 elif [ $basevalue = 2 ]; then
158 # module; handled in scripts/lookups-Makefile
159 true
160 else
161 # main binary
162 cflags=`pkg-config --cflags $pc_value`
163 libs=`pkg-config --libs $pc_value`
164 if [ "$var" != "${var#LOOKUP_}" ]; then
165 echo "LOOKUP_INCLUDE += $cflags"
166 echo "LOOKUP_LIBS += $libs"
167 elif [ "$var" != "${var#AUTH_}" ]; then
168 echo "CFLAGS += $cflags"
169 echo "AUTH_LIBS += $libs"
170 else
171 echo >&2 "Don't know how to handle pkg-config for $var"
172 fi
173 fi
174 ;;
f4b00a2d 175
dde3daac
PP
176 esac
177 done
178 echo "# End of pkg-config fixups"
179 echo
180 ) >> $mft
181fi
182rm -f $mftt
183
0a349494
PP
184# make the lookups Makefile with the definitions
185
186## prepend stuff here; eg: grep LOOKUP_ $mft > $look_mft
187## cat ../src/lookups/Makefile >> $look_mft
188cp ../src/lookups/Makefile $look_mft
61ec970d
PH
189
190# See if there is a definition of EXIM_PERL in what we have built so far.
191# If so, run Perl to find the default values for PERL_CC, PERL_CCOPTS,
192# and PERL_LIBS. These need to be put at the top of the Makefile, so we rename
193# what we have so far and then copy it afterwards. Use the value of PERL_COMMAND
194# if it has been defined.
195
196EXIM_PERL=`grep EXIM_PERL $mft`
197
198PERL_COMMAND=`grep PERL_COMMAND $mft | sed -e "\\$!d;s/^[$st]*PERL_COMMAND[$st]*=[$st]*//"`
199if [ "${PERL_COMMAND}" = "" ] ; then
200 PERL_COMMAND='perl'
201fi
202
203if [ "${EXIM_PERL}" != "" ] ; then
204 testperl=`$PERL_COMMAND --version`
205 if [ "$testperl" = "" ] ; then
206 echo "*** EXIM_PERL is set, but '$PERL_COMMAND --version' failed"
207 exit 1
208 fi
209
177ebd9b
NM
210 EXTUTILS_EMBED_NOT_INSTALLED=`$PERL_COMMAND -MExtUtils::Embed -e ";" 2>&1`
211 if [ "${EXTUTILS_EMBED_NOT_INSTALLED}" != "" ] ; then
212 echo "Please install ExtUtils::Embed for $PERL_COMMAND"
213 exit 1;
214 fi
215
61ec970d
PH
216 mv $mft $mftt
217 echo "PERL_CC=`$PERL_COMMAND -MConfig -e 'print $Config{cc}'`" >>$mft
218 echo "PERL_CCOPTS=`$PERL_COMMAND -MExtUtils::Embed -e ccopts`" >>$mft
219 echo "PERL_LIBS=`$PERL_COMMAND -MExtUtils::Embed -e ldopts`" >>$mft
220 echo "" >>$mft
221 cat $mftt >> $mft
222 rm -f $mftt
223fi
224
225# Record the build variable in the Makefile.
226
227echo "build=$build" >>$mft
228echo "" >>$mft
229
230# Finally, join on the generic base make file, which contains the actual
231# rules and stuff.
232
76ea0716 233echo "# From ../OS/Makefile-Base" >> $mft
61ec970d
PH
234cat ../OS/Makefile-Base >> $mft || exit 1
235
236# If the new makefile is the same as the existing one, say so, and just
237# update the timestamp. Otherwise remove the old and install the new.
238
0a349494 239if [ -s $mf ] && cmp -s $mft $mf && [ -s $look_mf ] && cmp -s $look_mft $look_mf
61ec970d
PH
240then echo ">>> rebuilt $mf unchanged"
241 echo " "
242 touch $mf || exit
243 rm -f $mft
0a349494 244elif rm -f $mf $look_mf
61ec970d 245 mv $mft $mf
0a349494
PP
246 mv $look_mft $look_mf
247then echo ">>> New $mf & $look_mf installed"
61ec970d
PH
248 echo '>>> Use "make makefile" if you need to force rebuilding of the makefile'
249 echo " "
250else echo " "
251 echo "*** Failed to install $mf - see $mft"
0a349494 252 echo " (or $look_mft)"
61ec970d
PH
253 echo " "
254 exit 1;
255fi
256
dde3daac 257# vim: set ft=sh :
61ec970d 258# End of Configure-Makefile